var FORUMS_ROOT		= "http://forums.clubrsx.com/";
var NEW_POSTS_URL	= FORUMS_ROOT + "search.php?do=getnew";
var FORUM_DISPLAY	= FORUMS_ROOT + "forumdisplay.php?f=";
var SUBSCRIPTIONS	= FORUMS_ROOT + "subscription.php?do=viewsubscription";
var	FAQ_URL			= FORUMS_ROOT + "faq.php?";
var	PM_URL			= FORUMS_ROOT + "private.php?";
var PM_XML_URL		= PM_URL + "do=downloadpm&dowhat=xml";
var DASH_PARAM		= "&dashboard=";

var NOT_LOGGED_IN		= "Not logged in";
var OFFLINE				= "Offline";
var NO_PERMISSION		= "you do not have permission";

var NO_SUBS		= "You have no Subscribed Threads.";
var NO_PMS		= "You have no Private Messages.";
var NO_THREADS	= "There are no threads in this forum.";

/*
 *	Thread listing constants and tokens used for scraping and list generation
 */
var NEW_POST_GIF	= "Images/buttons/firstnew.gif";

var GOTO_LASTPOST	= "showthread.php?goto=lastpost";
var SHOW_THREAD		= "showthread.php?";

var SUB_FORUM_LIST	= "<!-- sub-forum list  -->";
var END_SUB_FORUM	= "<!-- / sub-forum list  -->";
var TIME_SPAN		= '<span class="time">';
var FLOAT_RIGHT		= '<span style="float:right">';
var SPAN_CLOSE		= "</span>";
var HREF_CLOSE		= '">';
var STRONG_OPEN		= "<strong>";
var ANCHOR_CLOSE	= "</a>";
var JS_PARAM_OPEN	= "('";
var JS_PARAM_CLOSE	= "')";

var TD_ALT1ACTIVE	= '<td class="alt1Active"';
var TITLE_START		= ' title="';
var QUOTE			= '"';
var GT				= '>';

// end threads
 
/*
 *	Private Message constants and tokens.
 */

var INBOX_TAG		= '<folder name="Inbox">';
var FOLDER_CLOSE	= "</folder>";

var PM_OPEN			= "<privatemessage>";
var PM_CLOSE		= "</privatemessage>";
var DATE_OPEN		= "<datestamp>";
var DATE_CLOSE		= "</datestamp>";
var TITLE_OPEN		= "<title>";
var TITLE_CLOSE		= "</title>";
var FROM_OPEN		= "<fromuser>";
var FROM_CLOSE		= "</fromuser>";

var TIME_PM			= " PM";
var TIME_AM			= " AM";

// end pm

var ERROR_COMMENT			= "<!-- main error message -->";
var PERMISSIONS_COMMENT		= "<!-- permission error message - user not logged in -->";

var WELCOME			= "Welcome, ";
var DASH			= "-";
var COLON			= ":";
var PERIOD			= ".";
var SEMICOLON		= ";"

var DEFAULT_STRETCH_SIZE = 180; // 4 rows of single-line thread listings.
var FRONT_MOON 		= "frontMoon";
var BACK_MOON		= "backMoon";

var selectedForums	= new Array();

// Text to be displayed inside the 'userLabel' span on frontside.
var userText = null;

// Variables to keep track of the logo "moons" and matching forum selections
var frontMoons = new Array();
var backMoons = new Array();
var moonCoords = new Array();
var moonSelections = new Array();
var frontSelection;
var backSelection = 1;
var rollMoon = null;

// Auto-refresh time (ms)
var refreshTime = 300000;
var showing = false;

var mainContent;
var stretcher;
var flipFader;

var contentLoaded	= false;

// XMLHttpRequest objects: one for general content fetching, the other for
// grabbing the current username when the widget first loads
var newRequest	= null;
var faqRequest	= null;

// Set the onHide and onShow handlers for showing / hiding Dashboard
if (window.widget) {
	widget.onhide = onHide;
	widget.onshow = onShow;
	widget.onremove = onRemove;
}

// We stop the progress tach as its the only indeterminate operation; any active
// requests are allowed to go to completion
function onHide () {
		DEBUG("stopTach");
	// stop the tach in place; let it resume later
	window.clearInterval(tachTimer);
	tachTimer = null;
	showing = false;
}

function onShow () {
	// Only resume the tach if we're still waiting to load
	if (!contentLoaded) {
		tachTimer = window.setInterval("animateTach(true);", TACH_INTERVAL);
	}
	showing = true;
}

function onRemove () {
	// clear out the prefs
	DEBUG("onRemove");
	widget.setPreferenceForKey(null, widget.identifier + "_refreshSelection");
	for (var i in selectedForums) {
		widget.setPreferenceForKey(null, widget.identifier + "_forum" + i);
	}
}

// Initialize everything here
function loaded () {
	//toggleDebug();
	// send out a request to grab the username (if any)
	fetchUserName();
	
	mainContent = document.getElementById("contentDiv");
	createGenericButton(document.getElementById("doneButton"), "Done", prefsDone, 67);

	stretcher = new Stretcher(document.getElementById("front"), DEFAULT_STRETCH_SIZE, 500, changeContent);
	flipFader = new Fader(document.getElementById("flip"), null, 250);
	
	tachFader = new Fader(document.getElementById("tach"), null, 250);
	
	scrollerInit(document.getElementById("myScrollBar"), document.getElementById("myScrollTrack"), document.getElementById("myScrollThumb"));
	
	// set up default selections
	if (window.widget) {
		for (var i=1; i<=5; i++) {
			var prefSelection = widget.preferenceForKey(widget.identifier + "_forum" + i);
			if (prefSelection == null) {
				DEBUG("no prefs");
				loadDefaultForums();
				break;
			} else {
				selectedForums[i] = prefSelection;
			}
		}
		
		var selectionPref = parseInt(widget.preferenceForKey(widget.identifier + "_refreshSelection"));
		var refresher = document.getElementById("refresher");
		DEBUG("selectionPref=" + selectionPref + " reflen=" + document.getElementById("refresher").length);
		if (selectionPref >= 0 && selectionPref < refresher.length) { // this check should never fail, so it's kind of pointless
			refresher.selectedIndex = selectionPref;
			refreshTime = refresher[refresher.selectedIndex].value;
			DEBUG("refreshTime=" + refreshTime);
		}
	} else {
		loadDefaultForums();
	}
	
	
	DEBUG("/loaded");
}

function loadDefaultForums () {
	DEBUG("loading defaults");
	// Set dropdown indices of the desired forums
	selectedForums[1] = 3;			// The Basics
	selectedForums[2] = 18;			// Exterior & Interior
	selectedForums[3] = 39;			// Problems & Solutions
	selectedForums[4] = 63;			// Club RSX Lounge
	selectedForums[5] = 2;			// New Posts
}

// We want to get the username ASAP onload. Send a request to faq.php because 
// the content is static and the load time is quick.
function fetchUserName () {
		DEBUG("fetchUserName");
	faqRequest = new XMLHttpRequest();
	faqRequest.onreadystatechange = faqReqChange;
	faqRequest.open("GET", FAQ_URL, true);
	faqRequest.send();
}
function faqReqChange () {
	DEBUG("faqReqChange=" + faqRequest.readyState);
	if (faqRequest.readyState == 4) {
		if (faqRequest.status == 200) {
			findUserNameFromHTML(faqRequest.responseText);	
		} else updateUserText (OFFLINE);
	}
}

function fetchContentForMoon (number) {
	frontSelection = number;
	if (!stretcher.isStretched()) {
		stretcher.stretch();
	}
	contentLoaded = false;

	var selection = document.getElementById("forumSelection").options[selectedForums[number]].value;

	var theURL = null;
	var callback = getThreadsFromHTML;
	switch (selection) {
		case "pms":
			theURL = PM_XML_URL;
			callback = getInboxMessages;
			break;
		case "subs":	
			theURL = SUBSCRIPTIONS;
			break;
		case "newPosts":
			theURL = NEW_POSTS_URL;
			break;
		default:
			theURL = FORUM_DISPLAY + selection;
			break;
	}
		
	getContent(theURL, callback);
}

function getContent (url, callback) {
	
	document.getElementById("noResults").style.display = "none";
	hideError();
	
	if (refreshTimer != null) {
		window.clearInterval(refreshTimer);
		refreshTimer = null;
	}
	
	startTach();

		DEBUG("gc: url=" + url);
	parserCallback = callback; 
	contentURL = url;
	if (newRequest) newRequest.abort();
	newRequest = new XMLHttpRequest();
	newRequest.onreadystatechange = requestStateChange;
	// a little hack to prevent the cache from screwing with us
	var newURL = contentURL + DASH_PARAM + (new Date).getTime();
	newRequest.open("GET", newURL, true);
	newRequest.send(null);
}

function requestStateChange () {
		DEBUG("rsc: state=" + newRequest.readyState);
	if (newRequest.readyState == 4) {
		if (newRequest.status == 200) {
				DEBUG("200 status!");
			var	builtTable = parserCallback(newRequest.responseText);
			// Content is ready.. kill the tach
			stopTach();			
			doneLoading(builtTable);
			// We set the refresh as a timer interval, even though it could just 
			// be a timeout.  We do this because it's easier to abort it (timeouts can't be cancelled)
			refreshTimer = window.setInterval("refresh();", refreshTime);
			newRequest.abort();
		} else {
				DEBUG("rsc:problem (status= " + newRequest.status + ")");
			newRequest.abort();
			showError("Images/serverError.png");
		}
	}
}

function refresh () {
	if (!showing) return;
	DEBUG("refreshing");
	if (contentURL) {
		getContent(contentURL, parserCallback);
	}
}

function showContent () {
		DEBUG("showContent: " + mainContent.firstChild.childNodes.length);
	if (mainContent.firstChild.childNodes.length > 3) {
		mainContent.style.width = "378px";
		document.getElementById("myScrollTrack").style.display = "block";
	}
	mainContent.style.top = "0px";
	mainContent.style.display = "block";	
	
	calculateAndShowThumb(mainContent);
		DEBUG("/showContent");
}

function cClicked (event) {
	if (stretcher.isStretched() || contentLoaded) {
		stretcher.stretch(event);
	}
}

// callback from the httprequest; don't set the label and front selection until 
// this point, when we KNOW the selected forum actually loaded
function doneLoading (resultsTable) {
	if (resultsTable != null) {
		if (mainContent.firstChild) {
			mainContent.removeChild(mainContent.firstChild);
		}
		mainContent.appendChild(resultsTable);
	}
	contentLoaded = true;

	var currentTitle = document.getElementById("forumSelection").options[selectedForums[frontSelection]].text.match(/[\w]+.+/);
	var label = document.getElementById("currentViewLabel");
	if (label.firstChild) {
		label.firstChild.nodeValue = currentTitle;
	} else label.appendChild(document.createTextNode(currentTitle));
	label.style.display = "block";

	// sync the back moon selection to the front moon selection
	// can't perform selection right away because backside display=none
	selectMoon(FRONT_MOON, frontSelection);
	backSelection = frontSelection;
	
	changeContent();
}

function changeContent () {
	if (stretcher.isStretched() && contentLoaded && mainContent) {
		showContent();
	}
}


/*
 *	Rollover and selection functions for logo "moons"
 */
function frontMouseOver (moonNum) {
	mouseOverMoon(FRONT_MOON, moonNum);
}
function backMouseOver (moonNum) {
	mouseOverMoon(BACK_MOON, moonNum);
}
function mouseOverMoon (whichMoon, moonNum) {
	rollMoon = document.getElementById(whichMoon + moonNum);
	rollMoon.style.display = "block";	
		var forumSelection = document.getElementById("forumSelection").options[selectedForums[moonNum]];
	if (document.getElementById("front").style.display != "none") {
		var hoverLabel = document.getElementById("hoverLabel");
		if (hoverLabel.firstChild) {
			hoverLabel.removeChild(hoverLabel.firstChild);
		}
		hoverLabel.appendChild(document.createTextNode("View " + forumSelection.text.match(/[\w]+.+/)));
		hoverLabel.style.display = "block";
	}
}
function frontMouseOut () {
	rollOff(FRONT_MOON);
}	
function backMouseOut () {
	rollOff(BACK_MOON);
}
function rollOff (whichLogo) {
	if (rollMoon != null && rollMoon != moonSelections[whichLogo]) {
		rollMoon.style.display = "none";
	}
	document.getElementById("hoverLabel").style.display = "none";
}
function selectBackMoon (moonNum) {
	backSelection = moonNum;
	selectMoon(BACK_MOON, moonNum);
	var forumLabel = document.getElementById("forumCaption");
	if (forumLabel.firstChild != null) {
		forumLabel.removeChild(forumLabel.firstChild);
	}
	forumLabel.appendChild(document.createTextNode("Selection " + (moonNum) + ":"));
}
function selectMoon (whichLogo, moonNum) {
	if (moonSelections[whichLogo] != null) {
		moonSelections[whichLogo].style.display = "none";
	}
	moonSelections[whichLogo] = document.getElementById(whichLogo + moonNum);
	moonSelections[whichLogo].style.display = "block";
	
	// update the backside dropdown to match whatever's currently selected.
	document.getElementById("forumSelection").selectedIndex = selectedForums[moonNum];
}

function fadeInfoButton() {
	if (!flipFader.fadingIn) {
		flipFader.startFade(flipFader.now, 0.5);
		flipFader.fadingIn = true;
	}
} 
 
function updateText(parent, newText) {
	smartReplaceChild(parent, parent.firstChild, document.createTextNode(newText));
}

function smartReplaceChild(parent, outChild, inChild) {
	smartRemoveChild(parent, outChild);
	parent.appendChild(inChild);
}

function smartRemoveChild (parent, outChild) {
	if (outChild != null) {
		parent.removeChild(outChild);
	}
}


/*
 *********************
 * Content retrieval *
 *********************
 */

var contentURL		= null;
var parserCallback	= null;

var refreshTimer	= null;

// vBulletin doesn't give us XML feeds for forums/searches.  Worse, it sends responses as text/html
// so we can't get the DOM.  Even worse, the HTML is malformed, so overrideMimeType doesn't even help
// (DOM exceptions galore).  We need to bruteforce the HTML which is returned as a single string.

// I know, I should be using regexp.  Maybe next time.
function getThreadsFromHTML (htmlText) {
	popupSearchResults("rawThreads", htmlText);

	if (faqRequest) faqRequest.abort();
	
	if (checkForLoginError(newRequest.responseText)) {
		showError("Images/accessError.png");
	} else findUserNameFromHTML(htmlText);
	
	// REMOVE SUB-FORUMS.
	var currIndex = htmlText.indexOf(SUB_FORUM_LIST);
		//DEBUG("subforum index=" + currIndex);
	if (currIndex != -1) {
		currIndex = htmlText.indexOf(END_SUB_FORUM, currIndex);
			//DEBUG("endsubForum=" + currIndex);
	} else {
		currIndex = 0;
	}
	
	// REMOVE ALT TITLE.  This may contain a thread reference and screw up our parsing.
	currIndex = htmlText.indexOf(TD_ALT1ACTIVE, currIndex);
	var tempIndex = 0;
	
	var startTime = (new Date).getTime();	
	var iterations = 0;

	var resultsTable = document.createElement("div");
	resultsTable.setAttribute("class", "resultsDiv");
	
		//DEBUG("currIndex of " + TD_ALT1ACTIVE + " = " + currIndex);
	// Just get the first 25 hits.
	while((currIndex != -1) && (iterations <= 25)) {
		var newPostURL		= null;
		var showThreadURL	= null;
		var threadTitle		= null;
		var threadStarter	= null;
		var replyTime		= null;
		var replier			= null;
		var lastPostURL		= null;
		var titlePrefix		= " ";
		tempIndex = htmlText.indexOf(GT, currIndex);
		
		// STICKY?
		currIndex = htmlText.indexOf(SPAN_CLOSE, tempIndex);
		tempIndex = htmlText.indexOf(SHOW_THREAD, currIndex);
		var floatSpan = htmlText.substring(currIndex, tempIndex);
		
		// should we do poll?
		
		if (floatSpan.indexOf("Sticky") != -1) {
			//DEBUG("Sticky!");
			titlePrefix += "Sticky: ";
		}
		if (floatSpan.indexOf("Poll") != -1) {
			//DEBUG("Poll!");
			titlePrefix += "Poll: ";
		}
		
		// GET NEW POST URL
		currIndex = tempIndex;
//		currIndex = htmlText.indexOf(SHOW_THREAD, tempIndex);
		tempIndex = htmlText.indexOf(HREF_CLOSE, currIndex); 
		var url = htmlText.substring(currIndex, tempIndex);
			//DEBUG("gtfh: evaluating " + url + "for newpost status");
		if (url.indexOf("goto=newpost") != -1) {
				//DEBUG("&nbsp;&nbsp;gtfh: getNewPostURL. currIndex=" + currIndex + " tempIndex=" + tempIndex);
			newPostURL = wrapURL(url);
				DEBUG("  gtfh: newPostURL=" + newPostURL);
			// the next SHOW_THREAD url should be the thread title.
			currIndex = htmlText.indexOf(SHOW_THREAD, tempIndex);
			tempIndex = htmlText.indexOf(HREF_CLOSE, currIndex);
		}
		
		// GET THREAD TITLE
		showThreadURL = wrapURL(htmlText.substring(currIndex, tempIndex));
		currIndex = tempIndex + HREF_CLOSE.length;	// HREF_CLOSE.length==2, followed by a STRONG_OPEN (8 chars)
		tempIndex = htmlText.indexOf(HREF_CLOSE, currIndex);
		threadTitle = htmlText.substring(currIndex, tempIndex);
			DEBUG("    -gtfh: thread '" + threadTitle + "' (" + showThreadURL + ")");
			
		// GET THREAD STARTER
		tempIndex = currIndex = htmlText.indexOf(JS_PARAM_OPEN, currIndex) + JS_PARAM_OPEN.length;
		// starter name
		currIndex = htmlText.indexOf(HREF_CLOSE, tempIndex) + HREF_CLOSE.length;
		tempIndex = htmlText.indexOf(SPAN_CLOSE, currIndex);
			//DEBUG("&nbsp;&nbsp;gtfh: Getting starter. currIndex=" + currIndex + " tempIndex=" + tempIndex);
		threadStarter = htmlText.substring(currIndex, tempIndex);
			//DEBUG("&nbsp;&nbsp;&nbsp;&nbsp;--gtfh: Starter was " + threadStarter); // + " (" + memberURL + ")");
			
		// GET THREAD REPLY
		// reply time
		currIndex = htmlText.indexOf(TIME_SPAN, tempIndex) + TIME_SPAN.length;
		tempIndex = htmlText.indexOf(SPAN_CLOSE, currIndex);
		replyTime = htmlText.substring(currIndex, tempIndex);
		// replier
		currIndex = htmlText.indexOf(HREF_CLOSE, tempIndex) + HREF_CLOSE.length;
		tempIndex = htmlText.indexOf(ANCHOR_CLOSE, currIndex);
		replier = htmlText.substring(currIndex, tempIndex);
			//DEBUG("&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;---gtfh: Reply @" + lastReplyTime + " by " + replier);
	
		// GET LAST POST URL
		currIndex = htmlText.indexOf(GOTO_LASTPOST, tempIndex);
		
		// Very strange bug... If no cookies exist, the last post URL doesn't show up
		// and the parser freaks out, causing an infinite loop of the first thread.
		// A single visit to forums.clubrsx.com in Safari fixes the problem, so it must be
		// the bblastvisit/bblastactivity cookies.  
		// This wouldn't be a problem if XMLHttpRequest handled Set-Cookie headers
		// from Dashboard, but it does not.
		if (currIndex != -1) {
			tempIndex = htmlText.indexOf(HREF_CLOSE, currIndex);
			lastPostURL = wrapURL(htmlText.substring(currIndex, tempIndex));
				DEBUG("     ----gtfh: lastPostURL=" + lastPostURL + " currIndex=" + currIndex + " tempIndex=" + tempIndex);
		}
		
		addThreadListing(resultsTable, newPostURL, threadTitle, titlePrefix, showThreadURL, threadStarter, replyTime, replier, lastPostURL);
			// FINALLY: goto a new thread before resuming the loop
		currIndex = htmlText.indexOf(TD_ALT1ACTIVE, tempIndex);
		
		iterations++;
	}	
		DEBUG("***FINISHED.  " + iterations + " results in " + ((new Date).getTime()-startTime) + " msecs");
	
	if (document.getElementById("errorBox").style.display != "block" && resultsTable.childNodes.length == 0) {
		DEBUG("no results");
		noResultsMsg((contentURL == (SUBSCRIPTIONS)) ? NO_SUBS : NO_THREADS);
		DEBUG("done");
	}
	
	return resultsTable;
}

// Get the username, in case a Safari login happened behind our back.
function findUserNameFromHTML (htmlText) {
	var welcomeIndex = htmlText.indexOf(WELCOME);
	if (welcomeIndex != -1) {
		userName = htmlText.substring(welcomeIndex+WELCOME.length, htmlText.indexOf(PERIOD, welcomeIndex));
	} else {
		userName = NOT_LOGGED_IN;
	}
	updateUserText(userName);
	DEBUG("username: " + userText);
}

function updateUserText (userName) {
	userText = userName;
	
	var userLabel = document.getElementById("userLabel");
	if (userText == NOT_LOGGED_IN) {
			DEBUG("creating userLink");
		var link = document.createElement("a");
		link.setAttribute("href", wrapURL(""));
		link.setAttribute("id", "userLink");
		link.appendChild(document.createTextNode(userText));
		document.getElementById("userIcon").style.visibility = "hidden";
		smartReplaceChild(userLabel, userLabel.firstChild, link);
	} else {
		document.getElementById("userIcon").style.visibility = "hidden";
		updateText(userLabel, userText);
		if (userText != OFFLINE) {
			document.getElementById("userIcon").style.visibility = "visible";
		}
	}
}

function checkForLoginError (htmlText) {
	return (htmlText.indexOf(ERROR_COMMENT) != -1 || htmlText.indexOf(PERMISSIONS_COMMENT) != -1);
}

/*
 ****************
 *	PM parsing	*
 ****************
 */
function getInboxMessages (pmText) {
	popupSearchResults("rawThreads", pmText);
		
	if (checkForLoginError(pmText)) {
		showError("Images/accessError.png");
	}
	
	var resultsTable =  document.createElement("div");
	
	// Just get the Inbox folder
	var startIndex = pmText.indexOf(INBOX_TAG)+INBOX_TAG.length;
	pmText = pmText.substring(startIndex, pmText.indexOf(FOLDER_CLOSE, startIndex));
	
	var startIndex = pmText.indexOf(PM_OPEN);
	var threads = new Array;
	var threadInd = 0;
	while (startIndex != -1) {
		var endIndex = pmText.indexOf(PM_CLOSE, startIndex);
//			DEBUG("message: startIndex=" + startIndex + " endIndex=" + endIndex);
			
			// shouldn't I be using Date for this???
			var dateString = pmText.substring(pmText.indexOf(DATE_OPEN, startIndex)+DATE_OPEN.length, pmText.indexOf(DATE_CLOSE, startIndex));
			var dateAndTime = dateString.split(" ");
			dateString = dateAndTime[0];
			var timeString = dateAndTime[1];			
			var dateTokens = dateString.split(DASH);
			dateString = dateTokens[1] + DASH + dateTokens[2] + DASH + dateTokens[0];
			
			var timeTokens = timeString.split(COLON);
			var hour = parseInt(timeTokens[0]);
			if (hour < 12) {
				timeString += TIME_AM;
			} else {
				hour -= 12;
				timeString = "" + hour + COLON + timeTokens[1] + (hour==12 ? TIME_AM : TIME_PM);
			}
			
			var titleString = pmText.substring(pmText.indexOf(TITLE_OPEN, startIndex)+TITLE_OPEN.length, pmText.indexOf(TITLE_CLOSE, startIndex));
			var fromString = pmText.substring(pmText.indexOf(FROM_OPEN, startIndex)+FROM_OPEN.length, pmText.indexOf(FROM_CLOSE, startIndex));
				DEBUG("date: " + dateString + " timeString= " + timeString + " title: " + titleString + " from: " + fromString);
		
		threads[threadInd++] = { title:titleString, url:wrapURL("private.php"), from:fromString, date:dateString, time:timeString };
//		addPMListing(resultsTable, titleString, wrapURL("private.php"), fromString, dateString, timeString);
		
		startIndex = pmText.indexOf(PM_OPEN, endIndex);
	}
	for (var i=threads.length-1; i>=0; i--) {
		addPMListing(resultsTable, threads[i].title, threads[i].url, threads[i].from, threads[i].date, threads[i].time);
	}

	if (document.getElementById("errorBox").style.display != "block" && resultsTable.childNodes.length == 0) {
		noResultsMsg(NO_PMS);
	}
	return resultsTable;
}

/**********************
 * Content generation *
 **********************/
 
 function addPMListing (parentDiv, msgTitle, msgURL, msgOriginator, date, time) {
	return addThreadListing(parentDiv, null, msgTitle, null, msgURL, msgOriginator, date, time, null); 
}

function addThreadListing (parentDiv, firstPostLink, title, titlePrefix, titleLink, originator, time, replier, lastPostLink) {
	var rowDiv = document.createElement("div");
	rowDiv.setAttribute("class", "resultsRow"); 
	// TD element for the title (left) column
	var colDiv = document.createElement("div");
	colDiv.setAttribute("class", "leftCol");
	rowDiv.appendChild(colDiv);
		
	var titleSpan = document.createElement("div");
	titleSpan.setAttribute("class", "threadListing");
	// Start with the "go to first new post" icon link.
	// We check for null because there may not always be one
	// (if the entire thread has been read by the user)
	if (firstPostLink != null) {
		// This just gets better and better.  At some point &'s in vBulletin links
		// started coming as &amp;'s.
		//DEBUG("atl: firstPostLink: " + firstPostLink);
		firstPostLink = firstPostLink.replace(/&amp;/ig, "&");
		var newPostElt = document.createElement("a");
		newPostElt.setAttribute("href", firstPostLink);
		var newPostImg = document.createElement("img");
		newPostImg.setAttribute("class", "firstPostButton");
		newPostImg.setAttribute("src", NEW_POST_GIF);
		newPostElt.appendChild(newPostImg);
		
		titleSpan.appendChild(newPostElt);
		if (titlePrefix) {
			titlePrefix = " "  + titlePrefix;
		}
	}
	
	if (titlePrefix) {
		//DEBUG("atl: titlePrefix= " + titlePrefix);
		titleSpan.appendChild(document.createTextNode(" " + titlePrefix));
	}

	// Thread title / link
		//DEBUG("atl: titleLink: " + titleLink);
	var threadHREF = document.createElement("a");
	threadHREF.setAttribute("href", titleLink.replace(/&amp;/ig, "&"));
	threadHREF.innerHTML = title;
	titleSpan.appendChild(threadHREF);
	colDiv.appendChild(titleSpan);
	
	// Starter's name
	var starterDiv = document.createElement("div");
	starterDiv.setAttribute("class", "starter");
	starterDiv.appendChild(document.createTextNode(originator));
	colDiv.appendChild(starterDiv);

	var rightCol = document.createElement("div");
	rightCol.setAttribute("class", "rightCol");
	rowDiv.appendChild(rightCol);
	
	// Reply time.  We wrap it in a link to the last post.
	// PMs do not have a last post, so we just append the time in that case.
		//DEBUG("atl: creating replyTime");
	var timeSpan = document.createElement("div");
	timeSpan.setAttribute("class", "time");
	if (lastPostLink != null) {
		var lastPostHREF = document.createElement("a");
		lastPostHREF.setAttribute("href", lastPostLink.replace(/&amp;/ig, "&"));
		lastPostHREF.appendChild(document.createTextNode(time));
		timeSpan.appendChild(lastPostHREF);
	} else {
		timeSpan.appendChild(document.createTextNode(time));
	}
	rightCol.appendChild(timeSpan);
	
	// Replier's Name.  If this is a PM list, the only thing we get is time.
	if (replier != null) {
			//DEBUG("atl: creating replier");
		var replierSpan = document.createElement("div");
		replierSpan.setAttribute("class", "replier");
		replierSpan.appendChild(document.createTextNode(replier));
		rightCol.appendChild(replierSpan);
	}

	parentDiv.appendChild(rowDiv);
}

// Given a URL, wrap it in an openURL call if inside Dashboard
function wrapURL (theURL) {
	theURL = FORUMS_ROOT + theURL;
	if (window.widget) {
		theURL = "javascript:widget.openURL('" + theURL + "');";
	}	
	return theURL;
}

// No threads/PMs found display
function noResultsMsg (msg) {
	var msgDiv = document.getElementById("noResults");
	if (msgDiv.firstChild) msgDiv.removeChild(msgDiv.firstChild);
	msgDiv.appendChild(document.createTextNode(msg));
	msgDiv.style.display = "block";
}

/*
 *	Error box 
 */ 
function showError (imgURL) {
	document.getElementById("errorText").src = imgURL;
	document.getElementById("errorBox").style.display = "block";
}
function hideError () {
	document.getElementById("closeBox").src = "Images/close.tif";
	document.getElementById("errorBox").style.display = "none";
	stopTach();
}
 
/*
 ***************************
 * Tachometer progress bar *
 ***************************
 */
 
var tachFader;

var RATIOS = new Array();
	RATIOS[1] = 2.130 / 3.266; // 02-04 Type-S 1st->2nd
	RATIOS[2] = 1.517 / 2.130; // 2->3
	RATIOS[3] = 1.147 / 1.517; // 3->4
	RATIOS[4] = 0.921 / 1.147; // 4->5
	RATIOS[5] = 0.738 / 0.921; // 5->6

var SHIFT_INTERVAL		= 50; // different timer speed between shifts
var TACH_INTERVAL		= 70; // interval
var WIND_DRAG			= .8; // additional slowdown; apply with each shift

// How long (ms) before giving up on a forum request to go through;
var FORUM_TIMEOUT = 20000;

// Angles for rotation of the needle (radians)
var REDLINE = 4.22;
var BOUNCE = 4.10;
var angle = 0;
var angleIncrement = 0.10471975511965977;

var whichGear = 1;
var tachTimer = null;
var tachStartTime;

function startTach () {
	window.clearInterval(tachTimer);
	whichGear = 1;
	angle = 0;
	angleIncrement = 0.10471975511965977;
	tachStartTime = new Date().getTime();
	// Start 1st gear a little faster than the other gears (which use TACH_INTERVAL)
	tachTimer = window.setInterval("animateTach(true);", SHIFT_INTERVAL);
	tachFader.fadeIn();
}

function stopTach () {
	window.clearInterval(tachTimer);
	tachTimer = null;
	document.getElementById("canvas").getContext("2d").clearRect(0, 0, 90, 90);
	tachFader.fadeOut();
}

function animateTach (forward) {
	if (forward) {
		angle += angleIncrement;
	} else angle -= 0.10471975511965977;
	
	// timeout
	if (new Date().getTime() - tachStartTime > FORUM_TIMEOUT) {
		newRequest.abort();
		showError("Images/serverError.png");
	}
	
	if (forward) {
		if (angle > REDLINE) {
			if (whichGear < 5) {
				// When we redline 1st-4th, start a new timer for the shift bounceback
				window.clearInterval(tachTimer);
				tachTimer = window.setInterval("animateTach(false);", SHIFT_INTERVAL);
				angle -= 0.10471975511965977;
			} else {
				// Assuming top spd is in 5th, just tach out when we hit redline
				angle = BOUNCE;
			}
		}
	} else { // We're shifting, needle is going backwards
		if (angle <= (REDLINE * RATIOS[whichGear])) {
			// When the skipback hits where the next gear would logically be, 
			// start moving forward again with the new gear ratio
			window.clearInterval(tachTimer);
			angleIncrement *= RATIOS[whichGear] * WIND_DRAG;
			window.clearInterval(tachTimer);
			tachTimer = window.setInterval("animateTach(true);", TACH_INTERVAL);
			angle += 0.10471975511965977;
			whichGear++;
		}
	}
	
	// Quartz canvas API allows us to animate the needle
	var canvas = document.getElementById("canvas");
	var context = canvas.getContext("2d");
	context.clearRect(0, 0, 90, 90);
	context.save();
	context.translate(45, 45);
	var needle = new Image (90, 90);
	needle.src = "Images/needle.png";
	context.rotate (angle);
	context.translate(-45, -45);
	context.drawImage(needle, 0, 0, 90, 90);
	context.restore();
}

// end tach

/*
 ************************
 *	backside functions	*
 ************************
 */
function flipClick (event) {
		DEBUG("flipClick");
	hideError();
		DEBUG("fc: stretching");
	if (!stretcher.isStretched()) {
			//DEBUG("flipClick: need to collapse");
		stretcher.onFinished = showPrefs;
		stretcher.stretch();
	} else showPrefs();
}

function showPrefs () {
	if (window.widget) {
		window.widget.prepareForTransition("ToBack");
	}
	
	if (refreshTimer != null) {
		window.clearInterval(refreshTimer);
		refreshTimer = null;
	}

	document.getElementById("fliprollie").style.display = "none";
	// get image selection from prefs; otherwise set 1.
	document.getElementById("front").style.display = "none";
	document.getElementById("back").style.display = "block";
	
	selectBackMoon(backSelection);
	
	if (window.widget) {
		var selectionPref = parseInt(widget.preferenceForKey(widget.identifier + "_refreshSelection"));
		if (selectionPref) {
			document.getElementById("refresher").selectedIndex = selectionPref;
		}
		setTimeout("window.widget.performTransition()", 0);
	}
}

// Respond to a change in preferred forums on the backside.
function forumSelectionChange () {
	selectedForums[backSelection] = document.getElementById("forumSelection").selectedIndex;
	DEBUG(document.getElementById("forumSelection").selectedIndex);
}

function widgetNav (url) {
	if (window.widget) {
		widget.openURL(url);
	} else document.location = url;
}

function prefsDone () {
	goToFront();
}

function goToFront () {
	if (window.widget) {
		window.widget.prepareForTransition("ToFront");
	}
	
	// Set imageSelection from prefs.
	document.getElementById("back").style.display = "none";
	document.getElementById("front").style.display = "block";
	
	// PREF: get the refresh time
	var refresher = document.getElementById("refresher");
	refreshTime = parseInt(refresher[refresher.selectedIndex].value);
	DEBUG("refreshTime=" + refreshTime);
	
	if (window.widget) {
		widget.setPreferenceForKey(refresher.selectedIndex, widget.identifier + "_refreshSelection");
 		for (var i in selectedForums) {
 			DEBUG("setting pref: " + i + "=" + selectedForums[i]);
			widget.setPreferenceForKey(selectedForums[i], widget.identifier + "_forum" + i);
		//DEBUG("pd: refreshTime(ms)=" + refreshTime);
		}
	}
	
	var stretcherTimeout = 0;
	if (window.widget) {
		setTimeout("window.widget.performTransition();", 0);
		stretcherTimeout = 800; // give some time for the transition
	}
	if (stretcher.onFinished == showPrefs && stretcher.isStretched()) {
		// We stretched in order to show the prefs; shrink back when the front is shown
		stretcher.onFinished = returnFrontState;
		setTimeout("stretcher.stretch();", stretcherTimeout);  
	}
}

// Assuming we had to stretch/shrink to show the prefs, return to the
// content-based callback.
function returnFrontState () {
	stretcher.onFinished = changeContent;
}

// end backside

/*
 **************
 * Debug Code *
 **************
 */

var debugMode = false;

// write to the debug div.
function DEBUG(str) {
	if (debugMode) {
		if (window.widget) {
			alert(str);
		} else {
			var debugDiv = document.getElementById("debugDiv");
			debugDiv.appendChild(document.createTextNode(str));
			debugDiv.appendChild(document.createElement("br"));
			debugDiv.scrollTop = debugDiv.scrollHeight;
		}
	}
}

// toggle the debugMode flag, but only show the debugDiv if we're in Safari
function toggleDebug() {
	debugMode = !debugMode;
	if (debugMode == true && !window.widget) {
		document.getElementById("debugDiv").style.display = "block";
	} else {
		document.getElementById("debugDiv").style.display = "none";
	}
}

function popupSearchResults (windowName, dump) {
	if (debugMode) {
		var newWindow = window.open("", windowName, "width=320,height=240");
		if (newWindow) {
			if (typeof dump == "string") {
				newWindow.document.getElementsByTagName("body")[0].innerHTML = "<p>" + windowName + "</p><p>" + dump;
			} else {
				var par = document.createElement("p");
				par.appendChild(document.createTextNode(windowName));
				//newWindow.document.getElementsByTagName("body")[0].appendChild(par);
				newWindow.document.getElementsByTagName("body")[0].appendChild(dump);
			}
		}
	}
}